#!/usr/bin/env python
#import string
import sys

# マスターM1の読み込み(レコード数,顧客ID) --> m1_size, m1_list
m1_size = int(sys.stdin.readline())
#print(m1_size)
m1_list = []
for item in range(m1_size):
    item_string = (sys.stdin.readline()).strip()
    item_list = item_string.split(",")
    item_id = item_list[0]
    m1_list.append(item_id)

#print(m1_list[0])

# トランザクションT1の読み込み(レコード数,顧客ID) --> t1_size, t1_list
t1_size = int(sys.stdin.readline())
#print(t1_size)
t1_list = []
for item in range(t1_size):
    item_string = (sys.stdin.readline()).strip()
    item_list = item_string.split(",")
    item_id = item_list[0]
    t1_list.append(item_id)

#print(t1_list[0])

# 匿名加工マスターM2の読み込み(レコード数,仮ID) --> m2_size, m2_list
m2_size = int(sys.stdin.readline())
#print(m2_size)
m2_list = []
for item in range(m2_size):
    item_string = (sys.stdin.readline()).strip()
    item_list = item_string.split(",")
    item_id = item_list[0]
    m2_list.append(item_id)

#print(m2_list[0])

# 匿名加工ランザクションT2の読み込み(レコード数,仮ID) --> t2_size, t2_list
t2_size = int(sys.stdin.readline())
#print(t2_size)
t2_list = []
for item in range(t2_size):
    item_string = (sys.stdin.readline()).strip()
    item_list = item_string.split(",")
    item_id = item_list[0]
    t2_list.append(item_id)

#print(t2_list[0])

# トランザクションレコード数(顧客IDごと) --> rec1
rec1 = []
for item in range(m1_size):
    rec1.append(t1_list.count(m1_list[item]))

#for item in range(m1_size):
#    print(rec1[item])

# トランザクションレコード数(仮IDごと) --> rec2
rec2 = []
for item in range(m2_size):
    rec2.append(t2_list.count(m2_list[item]))

#for item in range(m2_size):
#    print(rec2[item])

# 再識別(レコード数マッチング) --> q
q = []
for item2 in range(m2_size):
    # レコード数同士の距離の最小値 --> min_dist
    # レコード数の最小値を実現した，M1の行番号 --> min_item1
    min_dist = min_id = -1
    for item1 in range(m1_size):
        dist = abs(rec2[item2] - rec1[item1])
        if min_dist == -1 or dist < min_dist:
            min_dist = dist
            min_item1 = item1
            

    q.append(min_item1+1)
    

# 識別結果標準出力
print(m2_size)
for item2 in range(m2_size):
   print(q[item2])

