#!/usr/bin/env ruby

## YA

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def apply(a, p)
  [p, a].transpose.sort.map{|x| x[1]}
end

def inv(p)
  n = p.size
  apply((0...n).to_a, p)
end

def unapply(a, p)
  apply(a, inv(p))
end

def shuffle(a)
  a.map{|x| [rand, x]}.sort.map{|x| x[1]}
end

def rand_perm0(n)
  (0...n).map{|i|[rand,i]}.sort.map{|x|x[1]}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end



def ano_rename(m, t)
  n = m.size
  y = rand_perm(n).map{|x| x.to_s}
  k2y = Hash.new
  m2 = []
  m.each do |s|
    a = s.split(/,/)
    k = a[0]
    k2y[k] = y[k2y.size] unless k2y[k]
    a[0] = k2y[k]
    m2 << a.join(',')
  end
  t2 = []
  t.each do |s|
    a = s.split(/,/)
    a[0] = k2y[a[0]]
    t2 << a.join(',')
  end
  return [m2, t2]
end

def ano_out(m0, t0, p)
  m, t = ano_rename(m0, t0)
  q = rand_perm(m.size)
  write_table(apply(m, q))
  write_table(shuffle(t))
  write_table(apply(p, q))
end

m = read_table()
t = read_table()

n = m.size
p = rand_perm(n)

ano_out(m, t, p)
