#!/usr/bin/env ruby

def read_table(f = $stdin)
  n = f.gets.chomp.to_i
  (0...n).map{f.gets.chomp}
end

def write_table(t, f = $stdout, no_line_num = false)
  f.puts t.size unless no_line_num
  f.puts t
end

def apply(a, p)
  [p, a].transpose.sort.map{|x| x[1]}
end

def inv(p)
  n = p.size
  apply((0...n).to_a, p)
end

def unapply(a, p)
  apply(a, inv(p))
end

def shuffle(a)
  a.map{|x| [rand, x]}.sort.map{|x| x[1]}
end

def rand_perm0(n)
  (0...n).map{|i|[rand,i]}.sort.map{|x|x[1]}
end

def rand_perm(n)
  shuffle((0...n).to_a)
end

m = read_table().map{|x| x.split(/,/)[2]}
t = read_table()
m2 = read_table().map{|x| x.split(/,/)[2]}
t2 = read_table()

n = m2.size
p = [m, (0...n).to_a].transpose.sort.transpose[1]
q = [m2, (0...n).to_a].transpose.sort.transpose[1]

# p(q^{-1}(x))
write_table(apply(p, q))
## p(q(x)) = apply(p, inv(q))(x)
