#!/usr/bin/env python3
#
# common.py

from sys import stdin

def read_ncat():
    l_a = []
    while True:
        a = []
        line = stdin.readline()
        if not line: break
        for n in range(int(line.strip())):
            line = stdin.readline()
            a.append(line.strip())
        l_a.append(a)
    return l_a

def read_ary(fname = False):
    a = []
    if fname and fname != '-':
        with open(fname, 'r') as f:
            for line in f.readlines():
                a.append(line.strip())
    else:
        while True:
            line = stdin.readline()
            if not line: break
            a.append(line.strip())
    return a

def write_ary(a, fname = False):
    if fname and fname != '-':
        with open(fname, 'w') as f:
            for line in a:
                f.write(line + '\n')
    else:
        for line in a:
            print(line)
